<?php
  include_once("htmlfuncs.php");
  
  //Returns the beginning page number given a current page, total pages and a displayable page range.
  function GetBeginPage($Page, $TotalPages, $Range)
  {
    $Result = $Page - floor($Range / 2);
    if ($Result < 1)
    {
      $Result = 1;
    }
    return $Result;
  }
  
  //Returns the ending page number given a current page, total pages and a displayable page range.
  function GetEndPage($Page, $TotalPages, $Range)
  {
    $Result = $Page + floor($Range / 2);
    if ($Result > $TotalPages)
    {
      $Result = $TotalPages;
    }
    return $Result;    
  }
  
  function PageURL($Page, $PageLink)
  {
    $Result = $PageLink."&Page=$Page";
    
    return $Result;
  }
  
  function pagemenu($Page, $TotalPages, $PageLink, $Width)
  {
    $Result    = "";
    $BeginPage = GetBeginPage($Page, $TotalPages, PageRange());
    $EndPage   = GetEndPage($Page,   $TotalPages, PageRange());
    $Pages     = $EndPage - $BeginPage;
    $CellWidth = $Width/($Pages+2);
    
    //Create the links.
    $Result .= Table(TRTDC("Page $Page of $TotalPages"));
    $Result .= "<TABLE>\n";
    $Result .= "<TR>";
    if ($Page > 1)
    {      
      $Result .= TDW(href("Previous", PageURL($Page - 1, $PageLink)), $CellWidth);
    }
    else
    {
      $Result .= TDW("&nbsp;", $CellWidth);
    }    
    for($i = $BeginPage; $i <= $EndPage; $i++)
    {
      if ($i != $Page)
      {
        $Result .= TDWC(href($i, PageURL($i, $PageLink)), $CellWidth);
      }
      else
      {
        $Result .= TDWC($Page, $CellWidth);
      }
    }
    if ($Page < $TotalPages)
    {      
      $Result .= TDWC(href("Next", PageURL($Page + 1, $PageLink)), $CellWidth);
    }
    else
    {
      $Result .= TDWC("&nbsp;", $CellWidth);
    }    
    $Result .= "</TR></TABLE>\n";
    return $Result;
  }
?>